<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Michael Husler (michael@akatose.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * This class processes the page content and saves it as a static file.
 * It is hooked into 'contentPostProc-output' of the class 'tslib_fe'.
 */
class tx_mda_autopublish_contentProc {

	function proc($params, $parent) {
	
		// Determine wether Typo3 thinks that this page is client
		// cachable. Also checks that there are no extra paremeters
		// that could have influenced the results.
		if ($parent->isClientCachable &&
		    ! count($_GET) &&
		    ! count($_POST)) {
		
			// Determine the file to publish to.
			$handle = fopen($parent->getSimulFileName(), 'w');
			
			// Write a header (genereated from the template
			// 'header_template.tpl') that will invalidate
			// the published page, when it is expired.
			// This requires, that the generated .html files
			// are also interpreted by PHP.
			fwrite($handle,
				str_replace(
					array(
						'###CREATION_DATE_GMT###',
						'###CACHE_EXPIRES_GMT###',
						'###CACHE_EXPIRES_TS###'
					),
					array(
						gmdate('D, d M Y H:i:s T'),
						gmdate('D, d M Y H:i:s T', $parent->cacheExpires),
						$parent->cacheExpires
					),
					file_get_contents(t3lib_extMgm::extPath('mda_autopublish').'ap/header_template.tpl')
				)
			);
			
			// Because the generated files have to be interpreted
			// by PHP, we must "escape" any php tags in the content
			// before writing it.
			fwrite($handle,
				str_replace(
					array(
						'<!--#',
						'<?php',
						'<?',
					),
					array(
						'&gt;!--#',
						'&gt;?php',
						"<?php echo '<?'; ?>"
					),
					$parent->content
				)
			);
			fclose($handle);
		}
	}
	
}
?>
